<template>
  <div v-if="isLoading || isError">
    <section
      class="d-flex flex-column justify-content-center align-items-center h-100"
    >
      <slot name="loading" v-if="isLoading">
        <template v-if="slots.loading"></template>
        <Spinner />
      </slot>
      <slot name="error" v-else-if="isError">
        <template v-if="slots.error"></template>
        <template v-else>something went wrong...</template>
      </slot>
    </section>
  </div>
  <slot v-else></slot>
</template>

<script setup>
import { useSlots, defineProps } from "vue";
import Spinner from "@/components/Spinner.vue";

const slots = useSlots();

defineProps({
  isLoading: { type: Boolean, required: true },
  isError: { type: Boolean, required: false },
});
</script>

<style scoped>
.content-state {
  height: 100%;
}
.content-state__wrapper {
  height: 100%;
  display: flex;
  flex-direction: column;
  justify-content: center;
}
</style>
